<template>
  <div class="flex flex-wrap">
    <a @click="$router.go(-1)">back</a>

    <div class="w-full sm:w-1/2 md:w-1/3 lg:w-1/3 xl:w-1/3 mb-4">
      <img class="image _bq" :src="picture.link" alt="Protest" />
      {{ picture.id }}
    </div>
    <div v-if="logged" class="w-full sm:w-1/2 md:w-1/3 lg:w-1/3 xl:w-1/3 mb-4">
      <div class="w-full content-center">
        <h1 class="text-3xl m-10">{{ picture.nom }}</h1>

        <p>
          {{ picture.description }}
        </p>
        <br />
        <p>
          {{ picture.localisation }}
        </p>
        <br /><br />

        <div v-if="error" class="error_alert border-l-4 p-2 m-10" role="alert">
          <p class="font-bold">Une erreur est survenue ...</p>
          <br />
          <p>{{ error }}</p>
        </div>

        <form
          ref="form"
          v-if="picture.parameters"
          :model="form"
          class="w-full self-center p-5"
        >
          <div class="flex flex-wrap md:items-center mb-6">
            <div class="md:w-1/4">
              <label
                class="block text-white-700 text-sm font-bold mb-2"
                for="print"
                style="float: right;"
              >
                Support
              </label>
            </div>
            <div class="md:w-3/4">
              <select
                v-model="form.print"
                @change="setFormatList($event)"
                style="color:black;"
              >
                <option value="" selected="selected"
                  >--- Sélectionner ---</option
                >
                <option
                  v-for="option in picture.parameters"
                  :key="option"
                  :value="option.parameter_print_id"
                  >{{ option.label }}</option
                >
              </select>
              <p
                v-if="form_error.print"
                class="text-red-500 text-sm font-bold m-1"
              >
                Veuillez sélectionner un support d'impression
              </p>
            </div>
          </div>

          <div class="flex flex-wrap md:items-center mb-6">
            <div class="md:w-1/4">
              <label
                class="block text-white-700 text-sm font-bold mb-2"
                for="format"
                style="float: right;"
              >
                Format
              </label>
            </div>
            <div class="md:w-3/4">
              <select
                :v-model="form.format"
                @change="setPrice($event)"
                style="color:black;"
              >
                <option>--- Sélectionner ---</option>
                <option
                  v-for="option in form.options_format"
                  :key="option"
                  :value="option.id"
                  selected="selected"
                  >{{ option.format.label }}</option
                >
              </select>
              <p
                v-if="form_error.format"
                class="text-red-500 text-sm font-bold m-1"
              >
                Veuillez sélectionner un format d'impression
              </p>
            </div>
          </div>

          <div class="flex flex-wrap md:items-center mb-6">
            <div class="md:w-1/4">
              <label
                class="block text-white-700 text-sm font-bold mb-2"
                for="quantity"
                style="float: right;"
              >
                Quantity
              </label>
            </div>
            <div class="md:w-3/4">
              <input
                @change="setPrice($event)"
                v-model="form.quantity"
                type="number"
                id="quantity"
                name="quantity"
                step="1"
                min="1"
                max="5"
                style="color:black;"
              />
            </div>
          </div>

          <div class="flex flex-wrap md:items-center mb-6">
            <div class="md:w-1/4">
              <label
                class="block text-white-700 text-sm font-bold mb-2"
                for="quantity"
                style="float: right;"
              >
                Prix ttc :
              </label>
            </div>
            <div class="md:w-3/4">
              <p>{{ form.price }}€</p>
            </div>
          </div>

          <div class="flex flex-wrap md:items-center mb-10">
            <br /><br />
            <div class="md:w-1/4"></div>
            <div class="md:w-3/4">
              <button
                class="shadow btn_submit focus:shadow-outline focus:outline-none text-white font-bold py-2 px-4 rounded"
                type="button"
                @click="addToCart()"
              >
                Ajouter au panier
              </button>
            </div>
          </div>
        </form>
        <div v-else class="error_alert border-l-4 p-2 m-10" role="alert">
          <p class="font-bold">Une erreur est survenue ...</p>
          <p>Aucun paramétrage</p>
        </div>
      </div>
    </div>

    <div class="w-full sm:w-2/2 md:w-3/3 lg:w-3/3 xl:w-3/3 mb-4">
      <p>Infos livraison etc ...</p>
    </div>
  </div>
</template>

<script>
import { mapActions, mapState } from "vuex";
import emitter from 'tiny-emitter/instance';

export default {
  name: "Picture",
  props: {
    msg: String,
  },
  data() {
    return {
      form: {
        print: "",
        format: {},
        options_format: "",
        quantity: 1,
        price: 0,
      },
      form_error: {
        print: false,
        format: false,
      },
      error: false,
    };
  },
  methods: {
    ...mapActions({
      fetchPicture: "picture/fetchPicture",
    }),
    addToCart() {
      let data = this.form;

      if (!this.validate(data)) {
        return;
      }

      let cart = {
        'photo_item' : data.format,
        'quantity' : data.quantity,
        'image_link' : this.picture.link,
        'image_name' : this.picture.nom
      };

      let current_cart = localStorage.getItem("cart");

      if (current_cart && current_cart.length > 0) {
        let temp = JSON.parse(localStorage.getItem("cart", cart));
        temp.push(cart);
        localStorage.setItem("cart", JSON.stringify(temp));
      } else {
        localStorage.setItem("cart", JSON.stringify([cart]));
      }
      emitter.emit('set_cart');
    },
    validate(data) {
      this.form_error.print = false;
      this.form_error.format = false;

      if (data.print == "") {
        this.form_error.print = true;
        return false;
      } else if (data.format == "") {
        this.form_error.format = true;
        return false;
      }
      return true;
    },
    setFormatList(event) {
      this.form.options_format = this.picture.parameters[
        event.target.value
      ].data;
      this.form.format = this.picture.parameters[event.target.value].data[0];
      this.setPrice();
    },
    setPrice(event) {
      if (event && event.srcElement.id != "quantity") {
        this.form.price = 0;
        this.form.price =
          this.form.options_format.find((obj) => obj.id == event.target.value)
            .format.price * this.form.quantity;
        this.form.format = this.form.options_format.find(
          (obj) => obj.id == event.target.value
        );
      } else {
        if (this.form.format.format) {
          this.form.price = this.form.format.format.price * this.form.quantity;
        }
      }
    },
  },
  computed: {
    ...mapState({
      picture: (state) => state.picture.picture,
    }),
  },
  async mounted() {
    this.fetchPicture(this.$route.params.id);
  },
  beforeCreate() {
    this.logged = localStorage.getItem("is_logged") == "true" ? true : false;
  },
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.image {
  width: 100%;
  padding: 3%;
}
</style>
